#include <allegro5/allegro.h>
#include <allegro5/allegro_image.h>
#include <allegro5/allegro_audio.h>
#include <allegro5/allegro_acodec.h>
#include <allegro5/allegro_font.h>
#include <allegro5/allegro_ttf.h>
#include <allegro5/allegro_primitives.h>
#include <stdio.h>
#include <time.h>


/* LINKER:
-LC:\allegro\lib
-lallegro.dll
-lallegro_image.dll
-lallegro_audio.dll
-lallegro_acodec.dll
-lallegro_font.dll
-lallegro_ttf.dll
-lallegro_primitives.dll
*/

const int WIDTH = 1000;
const int HEIGHT = 500;
//  nomi risorse
ALLEGRO_DISPLAY *display = NULL;
ALLEGRO_BITMAP *elicottero1 = NULL;
ALLEGRO_BITMAP *elicottero2 = NULL;
ALLEGRO_BITMAP *carro1_a = NULL;
ALLEGRO_BITMAP *carro1_b = NULL;
ALLEGRO_BITMAP *carro1_c = NULL;
ALLEGRO_BITMAP *carro2 = NULL;
ALLEGRO_BITMAP *background = NULL;
ALLEGRO_BITMAP *nuvole = NULL;
ALLEGRO_BITMAP *muretto = NULL;
ALLEGRO_BITMAP *missile = NULL;
ALLEGRO_BITMAP *bomba = NULL;
ALLEGRO_SAMPLE *music = NULL;
ALLEGRO_EVENT_QUEUE *event_queue = NULL;
ALLEGRO_FONT *font = NULL;

void destroy() {
    // distrugge la risorsa se caricata
    if (event_queue) al_destroy_event_queue(event_queue);
    if (music) al_destroy_sample(music);
    if (al_install_keyboard) al_uninstall_keyboard();
    if (elicottero1) al_destroy_bitmap(elicottero1);
    if (elicottero2) al_destroy_bitmap(elicottero2);
    if (carro1_a) al_destroy_bitmap(carro1_a);
    if (carro1_b) al_destroy_bitmap(carro1_b);
    if (carro1_c) al_destroy_bitmap(carro1_c);
    if (carro2) al_destroy_bitmap(carro2);
    if (background) al_destroy_bitmap(background);
    if (font) al_destroy_font(font);
    if (nuvole) al_destroy_bitmap(nuvole);
    if (muretto) al_destroy_bitmap(muretto);
    if (missile) al_destroy_bitmap(missile);
    if (bomba) al_destroy_bitmap(bomba);
    if (display) al_destroy_display(display);
}
int main(int argc, char* argv[]) {

    char c;
    printf("%s\n\n", argv[0]);
    printf("Run da CODE::BLOCK, le risorse devono esistere nella cartella del progetto xxx.cbp\n");
    printf("se lanciato dall'eseguibile le risorse devono esistere nella cartella dell'eseguibile.\n\n");
    printf("Il programma funzionera' in computer che non hanno MinGW e allegro5 se alla compilazione\n");
    printf("si aggiunge -satic (incorpora lib MinGW) e si e' copiato 'allegro_monolith-debug-5.2.dll'\n");
    printf("dalla cartella allegro\\bin nella cartella dell'eseguibile.\n\n");

    if (!al_init()) {
        destroy();
        printf("Errore durante l'inizializzazione di Allegro.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    if (!al_init_image_addon()) {
        destroy();
        printf("Errore durante l'inizializzazione di image_addon.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    display = al_create_display(WIDTH, HEIGHT);
    if (!display) {
        destroy();
        printf("Errore durante la creazione di create_display.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    if (!al_install_audio()) {
        destroy();
        printf("Errore durante l'inizializzazione di install_audio.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    if (!al_init_acodec_addon()) {
        destroy();
        printf("Errore durante l'inizializzazione di acodec_addon.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    if (!al_install_keyboard()) {
        destroy();
        printf("Errore durante l'inizializzazione di install_keyboard.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    if (!al_init_ttf_addon()) {
        destroy();
        printf("Errore durante l'inizializzazione di ttf_addon.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    if (!al_init_font_addon()) {
        destroy();
        printf("Errore durante l'inizializzazione di font_addon.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    elicottero1 = al_load_bitmap("elicottero1.png");
    if (!elicottero1) {
        destroy();
        printf("Errore durante il caricamento di elicottero1.png.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    elicottero2 = al_load_bitmap("elicottero2.png");
    if (!elicottero2) {
        destroy();
        printf("Errore durante il caricamento di elicottero2.png.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    carro1_a = al_load_bitmap("carro1_a.png");
    if (!carro1_a) {
        destroy();
        printf("Errore durante il caricamento del carro1_a.png.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    carro1_b = al_load_bitmap("carro1_b.png");
    if (!carro1_b) {
        destroy();
        printf("Errore durante il caricamento del carro1_b.png.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    carro1_c = al_load_bitmap("carro1_c.png");
    if (!carro1_c) {
        destroy();
        printf("Errore durante il caricamento del carro1_c.png.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    carro2 = al_load_bitmap("carro2.png");
    if (!carro2) {
        destroy();
        printf("Errore durante il caricamento del carro2.png.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    background = al_load_bitmap("sfondo.jpg");
    if (!background) {
        destroy();
        printf("Errore durante il caricamento dello sfondo.jpg.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    nuvole = al_load_bitmap("scrollnuvole.png");
    if (!nuvole) {
        destroy();
        printf("Errore durante il caricamento dell'immagine scrollnuvole.png.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    muretto = al_load_bitmap("scrollmuretto.png");
    if (!muretto) {
        destroy();
        printf("Errore durante il caricamento dell'immagine scrollmuretto.png.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    missile = al_load_bitmap("missile.png");
    if (!missile) {
        destroy();
        printf("Errore durante il caricamento dell'immagine missile.png.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    bomba = al_load_bitmap("bomba.png");
    if (!bomba) {
        destroy();
        printf("Errore durante il caricamento dell'immagine bomba.png.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    font = al_load_font("c:/Windows/Fonts/arial.ttf", 24, 0);
    if (!font) {
        destroy();
        printf("Errore durante il caricamento di c:/Windows/Fonts/arial.ttf.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    music = al_load_sample("Katy.ogg");
    if (!music) {
        destroy();
        printf("Errore durante il caricamento del file audio Katy.ogg.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    if (!al_reserve_samples(1)) {
        destroy();
        printf("Errore durante l'assegnazione del flusso audio 1.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    event_queue = al_create_event_queue();
    if (!event_queue) {
        destroy();
        printf("Errore durante la creazione di create_event_queue.\nPremi invio");
        scanf("%c", &c);
        return -1;
    }
    printf("Allegro5 inizializzato, tutte le risorse caricate.\n");

    al_init_primitives_addon();
    al_install_mouse(); // installing mouse

    al_register_event_source(event_queue, al_get_display_event_source(display)); // eventi schermo
    al_register_event_source(event_queue, al_get_keyboard_event_source()); // eventi tastiera
    al_register_event_source(event_queue, al_get_mouse_event_source()); // eventi mouse
    al_set_window_title(display, "la sequenza di disegno determina chi copre cosa.  USA LE FRECCE, M, N, T, S, B, 1, 2, 3, 4, SPAZIO e MOUSE!");
    al_play_sample(music, 1.0, 0.0, 1.0, ALLEGRO_PLAYMODE_LOOP, NULL);
    ALLEGRO_MOUSE_STATE mouse_state;

    int x = -100; // per calcolare le coordinate x degli elicotteri e carro2
    int t_missili = clock(); // cadenza missili
    int t_bombe = clock(); // cadenza bombe
    int cm_xy [200][2] = {{0},{0}}; // coordinate missili
    int cb_xy [200][2] = {{0},{0}}; // coordinate bombe
    int nm = 0; // numero missili
    int nb = 0; // numero bombe
    int fotogrammiNumero = 0; // incremento nel loop di gioco
    double tempoTrascorso = 0.0; // calcolato nel loop di gioco
    double prevTime = 0.0; // promemoria per calcolo differenza tempo
    int fps = 0; // conterr i fotogrammi disegnati al secondo
    int scrollmuretto_x = 0;
    int scrollnuvole_x = 0;
    int anim = 0;
    float velCarro1 = 1;
    float xCarro1 = 50;
    float rest = 0.01; // tempo assegnato per il completamento di un frame
    bool game_over = false; // true esce
    bool sun = false; // visualizza il sole
    bool text = true; // visualizza il testo
    bool sf = true; // visualizza lo sfondo
    bool e1 = true; // visualizza elicottero1
    bool e2 = true; // visualizza elicottero2
    bool c1 = true; // visualizza carro1
    bool c2 = true; // visualizza carro2
    bool n = true; // visualizza nuvole
    bool o = false; // visualizza missili (orizzontale)
    bool v = false; // visualizza bombe (verticale)
    bool m = true; // visualizza muretto
    char *sStamp[50] = {0}; // contiene la stringa completa di stampa
    // Buffer sporcabile
    ALLEGRO_BITMAP *bufferSfondo = al_create_bitmap(al_get_bitmap_width(background), al_get_bitmap_height(background));
    al_set_target_bitmap(bufferSfondo); // imposto la destinazione dei comandi grafici su bufferSfondo
        al_draw_bitmap(background, 0, 0, 0); // copio background su bufferSfondo
    al_set_target_backbuffer(display); // ripristino la destinazione della grafica sul display

    // Ciclo di gioco
    while (!game_over) {

        ALLEGRO_EVENT event; // coda degli eventi
        bool got_event = al_get_next_event(event_queue, &event);

        fotogrammiNumero++;

        // calcolo framerate usando l'istruzione allegro5: al_get_time()
        tempoTrascorso = al_get_time() - prevTime;

        if (tempoTrascorso >= 1.0) {
            fps = fotogrammiNumero;
            fotogrammiNumero = 0;
            tempoTrascorso = 0.0;
            prevTime = al_get_time();
        }

        /* // equivalente con i cicli di clock convertiti in secondi
        tempoTrascorso = clock()/CLOCKS_PER_SEC - prevTime;
        if (tempoTrascorso >= 1.0) {
            fps = fotogrammiNumero;
            fotogrammiNumero = 0;
            tempoTrascorso = 0.0;
            prevTime = clock()/CLOCKS_PER_SEC;
        }*/

        // controllo chiusura finestra
        if (event.type == ALLEGRO_EVENT_DISPLAY_CLOSE) game_over = true;
        // controllo eventi tastiera
        if (event.type == ALLEGRO_EVENT_KEY_DOWN) {
            // printf("Kc:%d ", event.keyboard.keycode);
            switch (event.keyboard.keycode) {
                case ALLEGRO_KEY_ESCAPE:
                    game_over = true;
                    break;
                case ALLEGRO_KEY_LEFT:
                    velCarro1 -= .1;
                    break;
                case ALLEGRO_KEY_RIGHT:
                    velCarro1 += .1;
                    break;
                case ALLEGRO_KEY_UP:
                    rest += 0.001;
                    break;
                case ALLEGRO_KEY_DOWN:
                    rest -= 0.001;
                    if (rest < 0) rest = 0;
                    break;
                case ALLEGRO_KEY_M:
                    m = !m;
                    break;
                case ALLEGRO_KEY_N:
                    n = !n;
                    break;
                case ALLEGRO_KEY_B:
                    sf = !sf;
                    break;
                case ALLEGRO_KEY_S:
                    sun = !sun;
                    if (sun) {
                        al_set_target_bitmap(bufferSfondo);
                            al_draw_filled_circle(800,100,40,al_map_rgb(250, 250, 0));
                        al_set_target_backbuffer(display);
                    }
                    else {
                        al_set_target_bitmap(bufferSfondo);
                            al_draw_bitmap(background, 0, 0, 0); // ripristino background su bufferSfondo
                        al_set_target_backbuffer(display);
                    }
                    break;
                case ALLEGRO_KEY_T:
                    text = !text;
                    break;
                case ALLEGRO_KEY_1:
                    e1 = !e1;
                    break;
                case ALLEGRO_KEY_2:
                    e2 = !e2;
                    break;
                case ALLEGRO_KEY_3:
                    c1 = !c1;
                    break;
                case ALLEGRO_KEY_4:
                    c2 = !c2;
                    break;
                case ALLEGRO_KEY_SPACE:
                    o = true;
                    cm_xy [nm][0]= WIDTH;
                    cm_xy [nm][1]= rand()%250 + 1;
                    nm++;
                    break;
            }
        }
        // controllo eventi mouse
        if (event.type == ALLEGRO_EVENT_MOUSE_BUTTON_DOWN) {

            al_get_mouse_state(&mouse_state);

            if (mouse_state.buttons & 1) { // tasto sinistro
                if (t_missili + 150 < clock()) { // 150 determina la cadenza dei missili
                    o = true; // attiva la visualizzazione dei missili
                    cm_xy [nm][0]= WIDTH;
                    cm_xy [nm][1]= event.mouse.y; // missili alla coordinata mouse.y
                    nm++;
                    t_missili = clock();
                }
            }
            else if (mouse_state.buttons & 2) { // tasto destro
                if (t_bombe + 50 < clock()) { // 50 determina la cadenza delle bombe
                    v = true;
                    cb_xy [nb][0] = rand()%1000 + 1; //bombe a caso // cb_xy [nv][0]=event.mouse.x; // bombe alle coordinate
                    cb_xy [nb][1] = -10;
                    nb++;
                    t_bombe = clock();
                }
            }
        }

        if (sf) al_draw_bitmap(bufferSfondo, 0, 0, 0); // sfondo fisso, cancella tutta la scena
        // Aggiorna la posizione delle immagini
        x ++; // elicotteri e carro2
        if (x > WIDTH) x = -200; // riparte fuori dallo schermo
        if (e2) al_draw_bitmap(elicottero2, x + 120, 100, 0); // elicottero2 resta dietro le nuvole
        if (c2) al_draw_bitmap(carro2, (WIDTH+20) -x * 1.2 , 260, 0); // carro2 resta dietro a carro1_abc

        xCarro1 += velCarro1;  // coordinata carro1_abc
        //if (xCarro1 > WIDTH) xCarro1 = -600; // riparte fuori dallo schermo
        //if (xCarro1 < -600) xCarro1 = WIDTH; // riparte fuori dallo schermo
        // equivalente ternario  meglio?
        xCarro1 = (xCarro1 > WIDTH ? -600 : (xCarro1 < -600 ? WIDTH : xCarro1));

        int speed = 19 + velCarro1 * 15; // velocit in Km/h, di fantasia
        snprintf(sStamp, sizeof(sStamp), "Carro1 %dKm/h - %dfps - ritardo %.3f''", speed, fps, rest);// creazione stringa per stampa a video

        if (c1) {
            if (speed > 0) { // ruote in avanti a b c
                switch (++anim) {
                   case 3:
                        anim=0;
                        al_draw_bitmap(carro1_a, xCarro1, 230, 1); // carro1_a resta dietro il muretto/cancello
                        break;
                   case 1:
                        al_draw_bitmap(carro1_b, xCarro1, 230, 1); // carro1_b resta dietro il muretto/cancello
                        break;
                   case 2:
                        al_draw_bitmap(carro1_c, xCarro1, 230, 1); // carro1_c resta dietro il muretto/cancello
                        break;
               }
            }

            if (speed == 0) al_draw_bitmap(carro1_a, xCarro1, 230, 1); // ruote ferme

            if (speed < 0) { // ruote indietro c b a
                switch (++anim) {
                   case 3:
                        anim=0;
                        al_draw_bitmap(carro1_c, xCarro1, 230, 1); // carro1_c resta dietro il muretto/cancello
                        break;
                   case 1:
                        al_draw_bitmap(carro1_b, xCarro1, 230, 1); // carro1_b resta dietro il muretto/cancello
                        break;
                   case 2:
                        al_draw_bitmap(carro1_a, xCarro1, 230, 1); // carro1_a resta dietro il muretto/cancello
                        break;
                }
            }
        }
        // Disegna lo scroll con nuvole due volte,
        // la seconda solo per coprire la larghezza dello schermo
        if (n) al_draw_bitmap_region(nuvole, 0, 0, 1000, HEIGHT, scrollnuvole_x, 0, 0);
        if (n) al_draw_bitmap_region(nuvole, 0, 0, WIDTH, HEIGHT, scrollnuvole_x + 1000, 0, 0);
        // stampa stringa preparata centrata
        if (text) al_draw_text(font, al_map_rgb(40, 20, 200), WIDTH/2, 230, ALLEGRO_ALIGN_CENTER, sStamp );
        if (e1) al_draw_bitmap(elicottero1, x*1.4, 70, 0); // elicottero1 resta avanti le nuvole
        // Aggiorna la coordinata dello scroll
        scrollnuvole_x -= 1;
        // Se l'immagine di scroll  uscita dallo schermo, torna all'inizio
        if (scrollnuvole_x <= -1000) scrollnuvole_x = 0;

        // salva di missili
        if (o) {
            for (int i = 0; i < nm; i++) {
                al_draw_bitmap(missile,  cm_xy[i][0], cm_xy[i][1], 1);
                cm_xy[i][0] -=5; // ogni missile ha le sue coordinate
            }
            if (cm_xy[nm - 1][0] < -100) {
                o = false; // l'ultimo missile lanciato  uscito dallo schermo
                nm = 0;
            }
        }

        // salva di bombe
        if (v) {
            for (int i = 0; i<nb; i++) {
                al_draw_bitmap(bomba, cb_xy[i][0], cb_xy[i][1], 0);
                cb_xy[i][1] += 4; // ogni bomba ha le sue coordinate
            }
            if (cb_xy[nb - 1][1] > HEIGHT) {
                v = false; // l'ultima bomba sganciata  uscita dallo schermo
                nb = 0;
            }
        }

        // Disegna lo scroll con muretto due volte,
        // la seconda solo per coprire la larghezza dello schermo
        if (m) al_draw_bitmap_region(muretto, 0, 0, 1000, HEIGHT, scrollmuretto_x, 257, 0);
        if (m) al_draw_bitmap_region(muretto, 0, 0, WIDTH, HEIGHT, scrollmuretto_x + 1000, 257, 0);
        // Aggiorna la coordinata dello scroll
        scrollmuretto_x -= 2;
        // Se l'immagine di scroll  uscita dallo schermo, torna all'inizio
        if (scrollmuretto_x <= -1000) scrollmuretto_x = 0;
        al_flip_display(); // scambia lo schermo al V_Sync
        al_rest(rest); // attende il tempo assegnato in secondi
    }
    destroy();
    return 0;
}
